#
#
# $Id: bbspost.rb,v 1.10 2004/01/11 14:22:11 Yuukis Exp $
#
#
# original code 'PostMessage2ch' from goRua 0.15(Pre).
# Imported when C.i. just started (PreAlpha). Thanx.

module BBSPost

	def BBSPost.post(board, thread, name, mailto, message)
		thread = thread.gsub(/\..*$/, '')
		url = "http://#{BBSMenu::Servers[board]}/test/read.cgi/#{board}/#{thread}/"
		flag, body = Net2ch.post(url, name, mailto, message)
		if flag
			return('OK')
		else
			err = '񤭹߼:'
			sperr = 'Υ顼: ƤǧƲ'
			case body
			when 'cookie'
				return([false, "#{sperr} CookieϢ ?"])
			when 'type_1_log'
				return([false, sperr])
			when 'type_2_log'
				return([false, sperr])
			when 'type_3'
				return([false, sperr])
			else
				return([false, "#{err} #{body}"])
			end
		end
	end

	def BBSPost.read_info(file)
		return([[CFG::Identity.name], [CFG::Identity.mailto]]) unless File.exist?(file)
		nArray = [] ; mArray = []
		IO.readlines(file).each {|x|
			case x
			when /^Name: (.*)/
				nArray << $1
			when /^Mail: (.*)/
				mArray << $1
			end
		}
		nArray.reverse! ; mArray.reverse!
		nArray << CFG::Identity.name unless nArray.include?(CFG::Identity.name)
		mArray << CFG::Identity.mailto unless mArray.include?(CFG::Identity.mailto)
		return([nArray, mArray])
	end

	def BBSPost.write_info(name, mail, file)
		if File.exist?(file)
			nArray = IO.readlines(file)
		else
			nArray = []
		end
		nArray.delete_if {|x| x == "Name: #{name}\n" or x == "Mail: #{mail}\n"}
		nArray << "Name: #{name}\n"
		nArray << "Mail: #{mail}\n"
		fh = open(file, 'w')
		fh.write nArray.uniq.join
		fh.close
	end


	module AA
		def AA.get_list
			if File.exist?("#{CFG::SYS.root}aa.list")
				fn = "#{CFG::SYS.root}aa.list"
			else
				fn = "#{CFG::SYS.siteroot}aa.list"
			end
			aalist = IO.readlines(fn)
			return(aalist)
		end
	end


	module Filter
		def Filter.get_list(flag = true)
			# return filter name array if flag = true
			# else return file name array 
			a = []
			Dir.glob("#{CFG::SYS.siteroot}filter/*").each {|x|
				if flag
					a << `#{x} -n` if File.executable?(x) && File.file?(x)
				else
					a << x if File.executable?(x) && File.file?(x)
				end
			}
			return(a)
		end
	
		def Filter.exec(name, str)
			fh = open("#{CFG::SYS.root}filter.cache", 'w')
			fh.write str
			fh.close
	
			fs = get_list(false)
			fs.each {|x|
				if `#{x} -n` == name
					y = `#{x} #{CFG::SYS.root}filter.cache`
					return(y)
				end
			}
		end
	end

end
