#
#
# $Id: gtkboards.rb,v 1.3 2003/11/20 13:55:52 Yuukis Exp $
#
#

class BoardSelector < GtkExt::BBSMenuTree

	class NodeData
		attr :uri

		def initialize(uri)
			@uri = uri
		end
	end

	def initialize
		super(["Board Name"], 0)
		insert
	end

	def update
		BBSMenu.get
		child.freeze
		child.clear
		child.thaw
		insert
	end

	def insert
		child.freeze
		root = child.insert_node(nil, nil, ["The 2ch Boards"], 1,
			nil, nil, nil, nil, false, true)
		nodes = BBSMenu.parse
		nodes.each {|info|
			if info[1] == 'C-'
				@semiRoot = child.insert_node(root, nil, [info[0]], 1,
					nil, nil, nil, nil, false, false)
			else
				node = child.insert_node(@semiRoot, nil, [info[0]], 1,
					nil, nil, nil, nil, true, false)
				child.node_set_row_data(node, NodeData.new(info[1]))
			end
		}
		child.thaw
	end
	private :insert
end
